package com.sagacloud.util.compute_engine.fjd;

import com.alibaba.fastjson.JSONObject;
import com.sagacloud.extend.dao_data.ImplDao_fjd_near;
import com.sagacloud.util.compute_engine.core.*;
import com.sagacloud.util.compute_engine.fjd_1.EntitySpan;
import com.sagacloud.util.compute_engine.fjd_1.EntityValidSpan;
import com.sagacloud.util.compute_engine.fjd_1.ProcessUtil2;
import com.sagacloud.util.compute_engine.util.*;
import com.sagacloud.util.split.HistoryUtil;
import com.sagacloud.util.split.SplitAlgorithm;
import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;
import java.util.*;

@Slf4j
public class Compute_fjd_1 {

    public static Map<String, List<TimeSpan>> Compute(String object_sign, String instance_name, List<CoreInput> inputList,
                                                      List<CoreOutput> outputList, long compute_round, Map<String, List<TimeSpan>> inputTimeSpanMap,
                                                      Map<String, List<TimeSpan>> outputdetailListMap, IDao_log dao_log) throws Exception {
        Map<String, CoreInput> inputMap = new HashMap<String, CoreInput>();
        for (CoreInput input : inputList) {
            inputMap.put(input.input_sign, input);
        }

        // 依次计算每个相关输出
        for (int i = 0; i < outputList.size(); i++) {
            CoreOutput output = outputList.get(i);
            CoreInput input = inputMap.get("ori_" + output.output_sign.substring("fjd_0_".length()));
            if (!input.source_output_sign.startsWith("Acc" + "_")) {
                continue;
            }

            Process(object_sign, compute_round, inputTimeSpanMap, input, output, dao_log);
        }

        return inputTimeSpanMap;
    }

    private static void Process(String object_sign, long compute_round, Map<String, List<TimeSpan>> inputTimeSpanMap, CoreInput input,
                                CoreOutput output, IDao_log dao_log) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

        String building = object_sign;

        String mf = output.output_sign.substring("fjd_0_".length());
        int index_ = mf.lastIndexOf('_');
        String meter = mf.substring(0, index_);
        long funcid = Long.parseLong(mf.substring(index_ + 1));
        if (!inputTimeSpanMap.containsKey(meter + "_" + funcid)) {
            return;
        }

        String time_period = input.time_period;
        long interval = DateUtil.Instance().get_about(time_period);
        List<TimeSpan> timeSpanList = inputTimeSpanMap.get(meter + "_" + funcid);

        Date time_from = timeSpanList.get(0).timefrom;
        Date time_to = timeSpanList.get(timeSpanList.size() - 1).timeto;

        Date time_from_query = new Date(time_from.getTime() - 1000L * ConstantCE.fjd_1_compute_min_span_second);
        List<DoubleTimeObject> recordDataList = Dao_dataManager.Instance().Get(input.dao_type).GetDataListGteLte(input.dao_key, null, time_from_query,
                DateUtil.Instance().GetDate_offset(time_to, time_period, ConstantCE.fjd_1_max_analyse_after_interval_count), true);

        if (recordDataList.size() == 0) {
            return;
        }

        List<DoubleTimeObject> badDataList = new ArrayList<DoubleTimeObject>();
        EntitySpan span = new EntitySpan();
        List<EntityValidSpan> validList = new ArrayList<EntityValidSpan>();
        boolean new_get_not_null = true;
        while (true) {
            if (new_get_not_null) {
                badDataList = new ArrayList<DoubleTimeObject>();
                span = new EntitySpan();
                validList = new ArrayList<EntityValidSpan>();
                ProcessUtil2.Process(building, meter, funcid, time_period, recordDataList, badDataList, span, validList);
            }

            if (validList.size() == 0) {
                break;
            }
            if (time_from.getTime() - time_from_query.getTime() > 1000L * 60 * 60 * 24 * ConstantCE.fjd_1_max_analyse_before_day) {
                break;
            }
            Date seek = DateUtil.Instance().GetDate_offset(time_from, time_period, -1);
            int seek_index = -1;
            for (int ii = 0; ii < recordDataList.size(); ii++) {
                DoubleTimeObject data = recordDataList.get(ii);
                if (data.data_time.getTime() >= seek.getTime()) {
                    seek_index = ii;
                    break;
                }
            }
            if (seek_index == -1) {
                break;
            }
            DoubleTimeObject seek_data = recordDataList.get(seek_index);
            boolean buyiyang = false;
            for (int ii = seek_index - 1; ii >= 0; ii--) {
                DoubleTimeObject data = recordDataList.get(ii);
                if (Math.abs(data.data_value - seek_data.data_value) >= 0.001) {
                    buyiyang = true;
                    break;
                }
            }
            if (buyiyang) {
                break;
            }

            Date next_from = new Date(time_from_query.getTime() - (time_from.getTime() - time_from_query.getTime()));
            List<DoubleTimeObject> tmpDataList = Dao_dataManager.Instance().Get(input.dao_type).GetDataListGteLte(input.dao_key, null, next_from,
                    time_from_query, false);
            new_get_not_null = tmpDataList.size() > 0;
            tmpDataList.addAll(recordDataList);
            recordDataList = tmpDataList;
            time_from_query = next_from;
        }

        // 处理badData
        if (badDataList.size() > 0) {
            Dao_dataManager.Instance().Get("ori_flag").InsertDataListGteLte(output.dao_key, time_period, badDataList);
        }

        if (validList.size() == 0) {
            return;
        }

        List<DoubleTimeObject_fjd_near> outDataList = new ArrayList<DoubleTimeObject_fjd_near>();
        int valid_index = 0;
        EntityValidSpan firstValid = validList.get(valid_index);
        int data_index = firstValid.index_from;
        while (valid_index < validList.size()) {
            // 判断当前点是不是zero和不变的起点
            int zero_index = -1;
            for (int i = 0; i < span.zeroList_from.size(); i++) {
                if (span.zeroList_from.get(i) == data_index) {
                    zero_index = i;
                    break;
                }
            }
            int stay_index = -1;
            for (int i = 0; i < span.stayList_from.size(); i++) {
                if (span.stayList_from.get(i) == data_index) {
                    stay_index = i;
                    break;
                }
            }
            int bianda_index = -1;
            for (int i = 0; i < span.changeList_bianda.size(); i++) {
                EntityValidSpan index_fromValid = validList.get(span.changeList_bianda.get(i));
                if (index_fromValid.index_to == data_index) {
                    bianda_index = i;
                    break;
                }
            }
            int bianxiao_index = -1;
            for (int i = 0; i < span.changeList_bianxiao.size(); i++) {
                EntityValidSpan index_fromValid = validList.get(span.changeList_bianxiao.get(i));
                if (index_fromValid.index_to == data_index) {
                    bianxiao_index = i;
                    break;
                }
            }

            DoubleTimeObject data = recordDataList.get(data_index);
            if (zero_index != -1) {
                if (stay_index != -1 || bianda_index != -1 || bianxiao_index != -1) {
                    log.error(
                            object_sign + "\t" + "fjd_1" + "\t" + compute_round + "\t" + meter + "\t" + funcid + "\t" + sdf.format(data.data_time));
                    return;
                }
                int index_to = span.zeroList_to.get(zero_index);
                DoubleTimeObject data_next = recordDataList.get(index_to);
                interpolate_history(time_from, building, meter, funcid, time_period, data, data_next, outDataList, 101L);
                data_index = index_to;
            } else if (stay_index != -1) {
                if (zero_index != -1 || bianda_index != -1 || bianxiao_index != -1) {
                    log.error(
                            object_sign + "\t" + "fjd_1" + "\t" + compute_round + "\t" + meter + "\t" + funcid + "\t" + sdf.format(data.data_time));
                    return;
                }
                int index_to = span.stayList_to.get(stay_index);
                DoubleTimeObject data_next = recordDataList.get(index_to);
                interpolate_history(time_from, building, meter, funcid, time_period, data, data_next, outDataList, 119L);
                data_index = index_to;
            } else if (bianda_index != -1) {
                if (zero_index != -1 || stay_index != -1 || bianxiao_index != -1) {
                    log.error(
                            object_sign + "\t" + "fjd_1" + "\t" + compute_round + "\t" + meter + "\t" + funcid + "\t" + sdf.format(data.data_time));
                    return;
                }
                DoubleTimeObject data_next = recordDataList.get(data_index + 1);
                interpolate_yanxu(time_from, interval, data, data_next, outDataList, 59L);
                DoubleTimeObject_fjd_near outData = new DoubleTimeObject_fjd_near();
                outData.data_time = new Date((data_next.data_time.getTime() - 1) / interval * interval + interval);
                outData.data_value = data_next.data_value;
                outData.data_flag = 3L;
                if (outData.data_time.getTime() >= time_from.getTime()) {
                    outDataList.add(outData);
                }
                data_index++;
            } else if (bianxiao_index != -1) {
                if (zero_index != -1 || stay_index != -1 || bianda_index != -1) {
                    log.error(
                            object_sign + "\t" + "fjd_1" + "\t" + compute_round + "\t" + meter + "\t" + funcid + "\t" + sdf.format(data.data_time));
                    return;
                }
                DoubleTimeObject data_next = recordDataList.get(data_index + 1);
                interpolate_yanxu(time_from, interval, data, data_next, outDataList, 51L);
                DoubleTimeObject_fjd_near outData = new DoubleTimeObject_fjd_near();
                outData.data_time = new Date((data_next.data_time.getTime() - 1) / interval * interval + interval);
                outData.data_value = data_next.data_value;
                outData.data_flag = 3L;
                if (outData.data_time.getTime() >= time_from.getTime()) {
                    outDataList.add(outData);
                }
                data_index++;
            } else {
                EntityValidSpan belongValid = validList.get(valid_index);
                if (data_index == belongValid.index_to) {
                    if (valid_index < validList.size() - 1) {
                        EntityValidSpan belongValidNext = validList.get(valid_index + 1);
                        DoubleTimeObject data_next = recordDataList.get(belongValidNext.index_from);
                        double energy = data_next.data_value - data.data_value;
                        double power = energy / (1.0 * (data_next.data_time.getTime() - data.data_time.getTime()) / (1000L * 60 * 60));
                        if (energy >= ConstantCE.fjd_1_monotony_sub && power <= ConstantCE.PowerLimit) {
                            interpolate_history(time_from, building, meter, funcid, time_period, data, data_next, outDataList, 102L);
                        }
                        data_index = belongValidNext.index_from;
                    } else {
                        data_index++;
                    }
                } else {
                    DoubleTimeObject data_next = recordDataList.get(data_index + 1);
                    interpolate(time_from, interval, data, data_next, outDataList, 0L);
                    data_index++;
                }
            }

            // 调整valid_index
            int find_index = -1;
            for (int i = 0; i < validList.size(); i++) {
                EntityValidSpan valid = validList.get(i);
                if (valid.index_from <= data_index && data_index <= valid.index_to) {
                    find_index = i;
                    break;
                }
            }
            if (find_index != -1) {
                valid_index = find_index;
            } else {
                if (data_index <= validList.get(validList.size() - 1).index_to) {
                    DoubleTimeObject data_tmp = recordDataList.get(data_index);
                    log.error(object_sign + "\t" + "fjd_1" + "\t" + compute_round + "\t" + "\t" + meter + "\t" + funcid + "\t" + "lose" + "\t"
                            + sdf.format(data_tmp.data_time));
                    return;
                }
                valid_index = validList.size();
            }
        }

        // 过滤掉大于time_to
        for (int i = outDataList.size() - 1; i >= 0; i--) {
            DoubleTimeObject_fjd_near outData = outDataList.get(i);
            if (outData.data_time.getTime() > time_to.getTime()) {
                outDataList.remove(i);
            }
        }
        // 比对并保存数据
        if (outDataList.size() == 0) {
            return;
        }

        DoubleTimeObject_fjd_near first_data_out = outDataList.get(0);
        DoubleTimeObject_fjd_near final_data_out = outDataList.get(outDataList.size() - 1);
        ImplDao_fjd_near dao_fjd_near = (ImplDao_fjd_near) Dao_dataManager.Instance().Get("fjd_near");
        List<DoubleTimeObject_fjd_near> fjdDataList = dao_fjd_near.GetDataListGteLte_fjd_near(input.dao_key, time_period, first_data_out.data_time,
                final_data_out.data_time, true);
        List<DoubleTimeObject_fjd_near> equalDataList = new ArrayList<DoubleTimeObject_fjd_near>();
        List<DoubleTimeObject_fjd_near> unequalDataList = new ArrayList<DoubleTimeObject_fjd_near>();
        List<DoubleTimeObject_fjd_near> delDataList = new ArrayList<DoubleTimeObject_fjd_near>();
        List<DoubleTimeObject_fjd_near> addDataList = new ArrayList<DoubleTimeObject_fjd_near>();
        CompareDataList(fjdDataList, outDataList, equalDataList, unequalDataList, delDataList, addDataList);

        if (unequalDataList.size() > 0) {
            DoubleTimeObject_fjd_near first_data = unequalDataList.get(0);
            DoubleTimeObject_fjd_near final_data = unequalDataList.get(unequalDataList.size() - 1);
            DoubleTimeObject_fjd_near continue_del = null;
            for (int i = 0; i < delDataList.size(); i++) {
                DoubleTimeObject_fjd_near tmp_del = delDataList.get(i);
                if (continue_del == null) {
                    continue_del = tmp_del;
                }

                if (i == delDataList.size() - 1) {
                    dao_fjd_near.DeleteDataListGteLte_fjd_1(input.dao_key, time_period, continue_del.data_time, tmp_del.data_time);
                } else {
                    DoubleTimeObject_fjd_near tmp_del_next = delDataList.get(i + 1);
                    if (tmp_del_next.data_time.getTime() - tmp_del.data_time.getTime() > interval) {
                        dao_fjd_near.DeleteDataListGteLte_fjd_1(input.dao_key, time_period, continue_del.data_time, tmp_del.data_time);
                        continue_del = tmp_del_next;
                    }
                }
            }
            ConstantCE.SleepBetweenDeleteAndInsert();
            dao_fjd_near.InsertDataListGteLte_fjd_1(input.dao_key, time_period, addDataList);

            // 统计
            DoubleTimeObject_fjd_near first_data_stat = addDataList.get(0);
            DoubleTimeObject_fjd_near final_data_stat = addDataList.get(addDataList.size() - 1);
            List<DoubleTimeObject_fjd_near> fjd_dataList_stat = dao_fjd_near.GetDataListGteLte_fjd_near(input.dao_key, time_period,
                    first_data_stat.data_time, final_data_stat.data_time, true);
            List<DoubleTimeObject> dataList_stat = new ArrayList<DoubleTimeObject>();
            for (DoubleTimeObject_fjd_near fjd_data : fjd_dataList_stat) {
                DoubleTimeObject data = new DoubleTimeObject();
                data.data_time = fjd_data.data_time;
                data.data_value = fjd_data.data_value;
                dataList_stat.add(data);
            }
            List<TimeSpan> timeSpanList_stat = new ArrayList<TimeSpan>();
            timeSpanList_stat.add(new TimeSpan(first_data_stat.data_time, final_data_stat.data_time));
            CoreComputeUtil.Stat_near("fjd_1", output.dao_key, timeSpanList_stat, time_period, dataList_stat);

            // 保存日志
            ImplDao_log ImplDao_log = (ImplDao_log) dao_log;
            {
                JSONObject Criteria = new JSONObject();
                Criteria.put("building", object_sign);
                Criteria.put("compute_round", compute_round);
                Criteria.put("meter", meter);
                Criteria.put("funcid", funcid);
                QueryUtil.delete(ImplDao_log.database_name, "fjd_1_computedetail", Criteria);
            }
            {
                JSONObject InsertObject = new JSONObject();
                InsertObject.put("building", object_sign);
                InsertObject.put("compute_round", compute_round);
                InsertObject.put("meter", meter);
                InsertObject.put("funcid", funcid);
                InsertObject.put("valid_time_from", sdf.format(first_data.data_time));
                InsertObject.put("valid_time_to", sdf.format(final_data.data_time));
                InsertObject.put("operate_time_to", sdf.format(new Date()));
                QueryUtil.insert(ImplDao_log.database_name, "fjd_1_computedetail", InsertObject);
            }
        }
    }

    public static void interpolate(Date time_from, long interval, DoubleTimeObject data, DoubleTimeObject data_next,
                                   List<DoubleTimeObject_fjd_near> outDataList, long data_flag) {
        Date compute_from = new Date((data.data_time.getTime() - 1) / interval * interval + interval);
        Date compute_to = new Date((data_next.data_time.getTime() - 1) / interval * interval);
        if (compute_to.getTime() < time_from.getTime()) {
            return;
        }

        for (Date date_tmp = compute_from; date_tmp.getTime() <= compute_to.getTime(); date_tmp = new Date(date_tmp.getTime() + interval)) {
            DoubleTimeObject_fjd_near outData = new DoubleTimeObject_fjd_near();
            outData.data_time = date_tmp;
            outData.data_value = data.data_value + (data_next.data_value - data.data_value)
                    * (1.0 * (outData.data_time.getTime() - data.data_time.getTime()) / (data_next.data_time.getTime() - data.data_time.getTime()));
            outData.data_flag = data_flag;
            if (outDataList.size() > 0) {
                DoubleTimeObject_fjd_near lastData = outDataList.get(outDataList.size() - 1);
                if (lastData.data_time.getTime() >= outData.data_time.getTime()) {
                    continue;
                }
            }
            outDataList.add(outData);
        }
    }

    public static void interpolate_yanxu(Date time_from, long interval, DoubleTimeObject data, DoubleTimeObject data_next,
                                         List<DoubleTimeObject_fjd_near> outDataList, long data_flag) {
        Date compute_from = new Date((data.data_time.getTime() - 1) / interval * interval + interval);
        Date compute_to = new Date((data_next.data_time.getTime() - 1) / interval * interval);
        if (compute_to.getTime() < time_from.getTime()) {
            return;
        }

        for (Date date_tmp = compute_from; date_tmp.getTime() <= compute_to.getTime(); date_tmp = new Date(date_tmp.getTime() + interval)) {
            DoubleTimeObject_fjd_near outData = new DoubleTimeObject_fjd_near();
            outData.data_time = date_tmp;
            outData.data_value = data.data_value;
            outData.data_flag = data_flag;
            if (outDataList.size() > 0) {
                DoubleTimeObject_fjd_near lastData = outDataList.get(outDataList.size() - 1);
                if (lastData.data_time.getTime() >= outData.data_time.getTime()) {
                    continue;
                }
            }
            outDataList.add(outData);
        }
    }

    public static void interpolate_history(Date time_from, String building, String meter, long funcid, String time_period, DoubleTimeObject data,
                                           DoubleTimeObject data_next, List<DoubleTimeObject_fjd_near> outDataList, long data_flag) throws Exception {
        long interval = DateUtil.Instance().get_about(time_period);
        Date compute_from = new Date((data.data_time.getTime() - 1) / interval * interval + interval);
        Date compute_to = new Date((data_next.data_time.getTime() - 1) / interval * interval);
        if (compute_to.getTime() < time_from.getTime()) {
            return;
        }

        DoubleTimeObject dataBegin = new DoubleTimeObject();
        dataBegin.data_time = compute_from;
        dataBegin.data_value = data.data_value;
        DoubleTimeObject dataEnd = new DoubleTimeObject();
        dataEnd.data_time = compute_to;
        dataEnd.data_value = data_next.data_value;
        JSONObject dao_key = new JSONObject();
        dao_key.put("building", building);
        dao_key.put("meter", meter);
        dao_key.put("funcid", funcid);
        IDao_data dao = Dao_dataManager.Instance().Get("servicedata");
        List<DoubleTimeObject> serviceDataList = ComputeRepair(dao, dao_key, time_period, dataBegin, dataEnd);
        long timeSpanCount = (dataEnd.data_time.getTime() - dataBegin.data_time.getTime()) / (interval);
        double total_add = 0.0;
        for (int i = 0; i < timeSpanCount; i++) {
            DoubleTimeObject servicedata = serviceDataList.get(i);
            DoubleTimeObject_fjd_near data_tmp = new DoubleTimeObject_fjd_near();
            data_tmp.data_time = new Date(compute_from.getTime() + interval * i);
            data_tmp.data_value = data.data_value + total_add;
            data_tmp.data_flag = data_flag;
            outDataList.add(data_tmp);
            total_add += servicedata.data_value;
        }
        {
            DoubleTimeObject_fjd_near data_tmp = new DoubleTimeObject_fjd_near();
            data_tmp.data_time = compute_to;
            data_tmp.data_value = data_next.data_value;
            data_tmp.data_flag = data_flag;
            outDataList.add(data_tmp);
        }
    }

    private static List<DoubleTimeObject> ComputeRepair(IDao_data dao, JSONObject dao_key, String time_period, DoubleTimeObject dataBegin,
                                                        DoubleTimeObject dataEnd) throws Exception {
        long interval = DateUtil.Instance().get_about(time_period);
        Calendar calendar = Calendar.getInstance();
        List<DoubleTimeObject> result = new ArrayList<DoubleTimeObject>();

        double energy = dataEnd.data_value - dataBegin.data_value;
        long timeSpanCount = (dataEnd.data_time.getTime() - dataBegin.data_time.getTime()) / (interval);

        List<Double> estimateArray = new ArrayList<Double>();
        List<Double> uncertaintyArray = new ArrayList<Double>();
        GetHistory(dao, dao_key, dataBegin.data_time, dataEnd.data_time, estimateArray, uncertaintyArray, time_period);
        List<Double> estimateValue = new ArrayList<Double>();
        List<Double> uncertaintyValue = new ArrayList<Double>();

        Date tmpTime = dataBegin.data_time;
        for (int iii = 0; iii < timeSpanCount; iii++) {
            calendar.setTime(tmpTime);
            int day_of_week = calendar.get(Calendar.DAY_OF_WEEK);
            int hour_of_day = calendar.get(Calendar.HOUR_OF_DAY);
            int index = (day_of_week - 1) * 24 + hour_of_day;

            Double estimate = null;
            Double uncertainty = null;
            for (int index_num = 0; index_num < 7; index_num++) {
                estimate = estimateArray.get((index + index_num * 24) % 168);
                uncertainty = uncertaintyArray.get((index + index_num * 24) % 168);
                if (estimate != null) {
                    break;
                }
            }
            estimateValue.add(estimate);
            uncertaintyValue.add(uncertainty);
            result.add(new DoubleTimeObject(new Date(dataBegin.data_time.getTime() + interval * iii), 0.0));

            tmpTime = new Date(tmpTime.getTime() + interval);
        }

        SplitAlgorithm.Instance().SolveByRatio(estimateValue, energy, result);

        return result;
    }

    private static void GetHistory(IDao_data dao, JSONObject dao_key, Date lostTimeFrom1, Date lostTimeFrom2, List<Double> estimateList,
                                   List<Double> uncertaintyList, String time_period) throws Exception {
        long timeSpanWeeks = 1000L * 60 * 60 * 24 * 28;

        List<DoubleTimeObject> serviceDataList = dao.GetDataListGteLte(dao_key, time_period, new Date(lostTimeFrom1.getTime() - timeSpanWeeks),
                new Date(lostTimeFrom2.getTime() + timeSpanWeeks), false);

        List<DoubleTimeObject> dataList = new ArrayList<DoubleTimeObject>();
        for (int i = 0; i < serviceDataList.size(); i++) {
            DoubleTimeObject serviceData = serviceDataList.get(i);
            dataList.add(new DoubleTimeObject(serviceData.data_time, serviceData.data_value));
        }
        HistoryUtil.Instance().GetHistory(dataList, estimateList, uncertaintyList);

        return;
    }

    private static void CompareDataList(List<DoubleTimeObject_fjd_near> oldDataList, List<DoubleTimeObject_fjd_near> newDataList,
                                        List<DoubleTimeObject_fjd_near> equalDataList, List<DoubleTimeObject_fjd_near> unequalDataList,
                                        List<DoubleTimeObject_fjd_near> delDataList, List<DoubleTimeObject_fjd_near> addDataList) {
        int index_old = 0;
        int index_new = 0;
        while (index_old < oldDataList.size() && index_new < newDataList.size()) {
            DoubleTimeObject_fjd_near oldData = oldDataList.get(index_old);
            DoubleTimeObject_fjd_near newData = newDataList.get(index_new);
            if (oldData.data_time.getTime() < newData.data_time.getTime()) {
                delDataList.add(oldData);
                DoubleTimeObject_fjd_near data = new DoubleTimeObject_fjd_near();
                data.data_time = oldData.data_time;
                data.data_value = oldData.data_value;
                data.data_flag = 250L;
                addDataList.add(data);
                unequalDataList.add(oldData);
                index_old++;
            } else if (oldData.data_time.getTime() > newData.data_time.getTime()) {
                addDataList.add(newData);
                unequalDataList.add(oldData);
                index_new++;
            } else {
                if (oldData.data_flag == newData.data_flag && Math.abs(oldData.data_value - newData.data_value) < 0.001) {
                    equalDataList.add(newData);
                } else {
                    unequalDataList.add(oldData);
                    delDataList.add(oldData);
                    addDataList.add(newData);
                }
                index_old++;
                index_new++;
            }
        }
    }
}
