package com.sagacloud.util.compute_engine.fjd;

import com.alibaba.fastjson.JSONObject;
import com.sagacloud.extend.dao_data.ImplDao_fjd_near;
import com.sagacloud.extend.dao_data.ImplDao_report;
import com.sagacloud.extend.dao_data.ImplDao_report_change_meter;
import com.sagacloud.util.compute_engine.core.*;
import com.sagacloud.util.compute_engine.util.*;
import com.sagacloud.util.split.HistoryUtil;
import com.sagacloud.util.split.SplitAlgorithm;

import java.text.SimpleDateFormat;
import java.util.*;

public class Compute_servicedata {
    public static Map<String, List<TimeSpan>> Compute(String object_sign, String instance_name, List<CoreInput> inputList,
                                                      List<CoreOutput> outputList, long compute_round, Map<String, List<TimeSpan>> inputTimeSpanMap,
                                                      Map<String, List<TimeSpan>> outputdetailListMap, IDao_log dao_log) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        Map<String, CoreInput> inputMap = new HashMap<String, CoreInput>();
        for (CoreInput input : inputList) {
            inputMap.put(input.input_sign, input);
        }

        // 确定相关输出需要计算的时间段，以及每个输入每种精度要取的数据的时间范围（去掉已经计算的output的时间段）
        Map<String, List<TimeSpan>> outputTimeSpanMap = new HashMap<String, List<TimeSpan>>();
        for (int i = 0; i < outputList.size(); i++) {
            CoreOutput output = outputList.get(i);
            List<TimeSpan> timeSpanList = new ArrayList<TimeSpan>();
            {
                String input_sign = "meterdata_" + output.output_sign.substring("servicedata_".length());
                CoreInput input = inputMap.get(input_sign);
                if (inputTimeSpanMap.containsKey(input_sign)) {
                    List<TimeSpan> timeSpanList_input = inputTimeSpanMap.get(input_sign);
                    DateUtil.Instance().ConvertAndMergeTo(timeSpanList_input, output.time_period, input.data_class, timeSpanList);
                }
            }
            DateUtil.Instance().Limit(timeSpanList, output.time_begin, DateUtil.Instance().GetDate_offset(output.time_end, output.time_period, -1));
            List<TimeSpan> timeSpanList_finish = outputdetailListMap.get(output.output_sign);
            for (int ii = timeSpanList.size() - 1; ii >= 0; ii--) {
                TimeSpan timeSpan = timeSpanList.get(ii);
                boolean finish = false;
                if (timeSpanList_finish != null) {
                    for (TimeSpan timeSpanInner : timeSpanList_finish) {
                        if (timeSpanInner.timefrom.getTime() == timeSpan.timefrom.getTime()) {
                            finish = true;
                            break;
                        }
                    }
                }
                if (finish) {
                    timeSpanList.remove(ii);
                }
            }

            outputTimeSpanMap.put(output.output_sign + "_" + sdf.format(output.time_begin), timeSpanList);
        }

        // 依次计算每个相关输出
        for (int i = 0; i < outputList.size(); i++) {
            CoreOutput output = outputList.get(i);
            String input_sign = "meterdata_" + output.output_sign.substring("servicedata_".length());
            CoreInput input = inputMap.get(input_sign);

            String time_period = output.time_period;
            long interval = DateUtil.Instance().get_about(time_period);
            List<TimeSpan> timeSpanList = outputTimeSpanMap.get(output.output_sign + "_" + sdf.format(output.time_begin));
            List<TimeSpan> timeSpanListOut = new ArrayList<TimeSpan>();
            List<DoubleTimeObject> outputDataList_all = new ArrayList<DoubleTimeObject>();
            // 变比
            Double rate = 1.0;
            int index_ = output.expression.lastIndexOf('*');
            if (index_ != -1) {
                rate = Double.parseDouble(output.expression.substring(index_ + 1));
            }
            if ("report".equals(input.source_instance_name)) {
                Date time_frist = null;
                Date time_final = null;
                for (TimeSpan timeSpan : timeSpanList) {
                    if (time_frist == null) {
                        time_frist = timeSpan.timefrom;
                        time_final = timeSpan.timefrom;
                    }
                    if (time_frist.getTime() > timeSpan.timefrom.getTime()) {
                        time_frist = timeSpan.timefrom;
                    }
                    if (time_final.getTime() < timeSpan.timefrom.getTime()) {
                        time_final = timeSpan.timefrom;
                    }
                }
                // 处理抄表读数
                if (time_frist != null) {
                    ImplDao_report dao_report = (ImplDao_report) Dao_dataManager.Instance().Get("report");
                    DoubleTimeObject report_last = dao_report.read_data_last(input.dao_key, time_frist);
                    DoubleTimeObject report_next = dao_report.read_data_next(input.dao_key, time_final);

                    ImplDao_report_change_meter dao_report_change = (ImplDao_report_change_meter) Dao_dataManager.Instance()
                            .Get("report_change_meter");
                    DoubleTimeObject_change report_change_last = dao_report_change.GetData_last(input.dao_key, time_frist);
                    DoubleTimeObject_change report_change_next = dao_report_change.GetData_next(input.dao_key, time_final);

                    Date real_from = time_frist;
                    Date real_to = time_final;
                    if (report_last != null || report_change_last != null) {
                        if (report_last != null && report_change_last == null) {
                            real_from = report_last.data_time;
                        } else if (report_last == null && report_change_last != null) {
                            real_from = report_change_last.data_time;
                        } else {
                            real_from = report_last.data_time.getTime() > report_change_last.data_time.getTime() ? report_last.data_time
                                    : report_change_last.data_time;
                        }
                    }
                    if (report_next != null || report_change_next != null) {
                        if (report_next != null && report_change_next == null) {
                            real_to = report_next.data_time;
                        } else if (report_next == null && report_change_next != null) {
                            real_to = report_change_next.data_time;
                        } else {
                            real_to = report_next.data_time.getTime() > report_change_next.data_time.getTime() ? report_next.data_time
                                    : report_change_next.data_time;
                        }
                    }

                    if (real_from.getTime() < real_to.getTime()) {
                        List<DoubleTimeObject> reportList = dao_report.read_data_GteLte(input.dao_key, real_from, real_to, true);
                        List<DoubleTimeObject_change> changeList = dao_report_change.GetDataList(input.dao_key, real_from, real_to);
                        DoubleTimeObject last_obj = null;
                        DoubleTimeObject curr_obj = null;
                        int index_report = 0;
                        int index_change = 0;
                        while (true) {
                            DoubleTimeObject bak_report = null;
                            if (index_report < reportList.size()) {
                                bak_report = reportList.get(index_report);
                            }
                            DoubleTimeObject_change bak_change = null;
                            if (index_change < changeList.size()) {
                                bak_change = changeList.get(index_change);
                            }

                            DoubleTimeObject report_change;
                            if (bak_report == null && bak_change == null) {
                                break;
                            } else if (bak_report != null && bak_change == null) {
                                report_change = bak_report;
                                index_report++;
                            } else if (bak_report == null && bak_change != null) {
                                report_change = bak_change;
                                index_change++;
                            } else {
                                if (bak_report.data_time.getTime() < bak_change.data_time.getTime()) {
                                    report_change = bak_report;
                                    index_report++;
                                } else {
                                    report_change = bak_change;
                                    index_change++;
                                }
                            }
                            last_obj = curr_obj;
                            curr_obj = report_change;
                            if (last_obj != null) {
                                Date last_floor = DateUtil.Instance().get_floor(last_obj.data_time, time_period);
                                Date curr_floor = DateUtil.Instance().get_floor(curr_obj.data_time, time_period);
                                if (curr_floor.getTime() > last_floor.getTime()) {
                                    double value_from = last_obj.data_value;
                                    double value_to = curr_obj.data_value;
                                    if (curr_obj instanceof DoubleTimeObject_change) {
                                        value_to = ((DoubleTimeObject_change) curr_obj).data_old;
                                    }
                                    long time_count = (curr_floor.getTime() - last_floor.getTime()) / DateUtil.Instance().get_about(time_period);
                                    for (Date tmp_time = last_floor; tmp_time.getTime() < curr_floor.getTime(); tmp_time = DateUtil.Instance()
                                            .GetDate_offset(tmp_time, time_period, 1)) {
                                        DoubleTimeObject tmp_data = new DoubleTimeObject();
                                        tmp_data.data_time = tmp_time;
                                        tmp_data.data_value = ((value_to - value_from) / time_count) * rate;
                                        outputDataList_all.add(tmp_data);
                                    }
                                }
                            }
                        }
                    }
                }
                // 处理抄表能耗
                if (time_frist != null) {
                    ImplDao_report dao_report = (ImplDao_report) Dao_dataManager.Instance().Get("report");
                    List<DoubleTimeObject_reportenergy> reportList = dao_report.energy_GteLte(input.dao_key, time_frist, time_final, true);
                    for (DoubleTimeObject_reportenergy reportenergy : reportList) {
                        long time_count = (reportenergy.time_to.getTime() - reportenergy.time_from.getTime())
                                / DateUtil.Instance().get_about(time_period);
                        for (Date tmp_time = reportenergy.time_from; tmp_time.getTime() < reportenergy.time_to.getTime(); tmp_time = DateUtil
                                .Instance().GetDate_offset(tmp_time, time_period, 1)) {
                            DoubleTimeObject tmp_data = new DoubleTimeObject();
                            tmp_data.data_time = tmp_time;
                            tmp_data.data_value = (reportenergy.data / time_count) * rate;
                            boolean exist = false;
                            if (outputDataList_all.size() > 0) {
                                DoubleTimeObject tmp_data_last = outputDataList_all.get(outputDataList_all.size() - 1);
                                if (tmp_data_last.data_time.getTime() >= tmp_data.data_time.getTime()) {
                                    exist = true;
                                }
                            }
                            if (!exist) {
                                outputDataList_all.add(tmp_data);
                            }
                        }
                    }
                }
                if (outputDataList_all.size() > 0) {
                    DoubleTimeObject data_first = outputDataList_all.get(0);
                    DoubleTimeObject data_final = outputDataList_all.get(outputDataList_all.size() - 1);
                    TimeSpan timeSpanOut = new TimeSpan(data_first.data_time, data_final.data_time);
                    timeSpanListOut.add(timeSpanOut);

                    // 删除数据
                    Dao_dataManager.Instance().Get(output.dao_type).DeleteDataListGteLte(output.dao_key, time_period, timeSpanOut.timefrom,
                            timeSpanOut.timeto);
                    ConstantCE.SleepBetweenDeleteAndInsert();
                    // 保存数据
                    Dao_dataManager.Instance().Get(output.dao_type).InsertDataListGteLte(output.dao_key, time_period, outputDataList_all);
                    timeSpanListOut.add(timeSpanOut);
                }
            } else {
                for (TimeSpan timeSpan : timeSpanList) {
                    // 准备数据
                    ImplDao_fjd_near dao_fjd_near = (ImplDao_fjd_near) Dao_dataManager.Instance().Get(input.dao_type);
                    Date timefrom_last = DateUtil.Instance().GetDate_offset(timeSpan.timefrom, time_period, -1);
                    Date timeto_last = DateUtil.Instance().GetDate_offset(timeSpan.timeto, time_period, -1);
                    List<DoubleTimeObject_fjd_near> inputDataList = dao_fjd_near.GetDataListGteLte_fjd_near(input.dao_key, time_period, timefrom_last,
                            timeSpan.timeto, true);
                    int start_index = 0;
                    if (inputDataList.size() > 0) {
                        DoubleTimeObject_fjd_near fjd_near = inputDataList.get(0);
                        if (fjd_near.data_time.getTime() == timefrom_last.getTime()) {
                            start_index = 1;
                        }
                    }

                    // 逻辑完备的，将未丢数的结果放入serviceDataList，丢书的放到recordDataBeginList、recordDataEndList中等待计算
                    List<DoubleTimeObject> outputDataList = new ArrayList<DoubleTimeObject>();
                    if (input.data_type != null && "InAc".equals(input.data_type)) {
                        for (int index = start_index; index < inputDataList.size(); index++) {
                            DoubleTimeObject_fjd_near inputData = inputDataList.get(index);
                            DoubleTimeObject serviceData = new DoubleTimeObject(new Date(inputData.data_time.getTime() - interval),
                                    inputData.data_value * rate);
                            outputDataList.add(serviceData);
                        }
                    } else {
                        List<DoubleTimeObject_fjd_near> intervalDataBeginList = new ArrayList<DoubleTimeObject_fjd_near>();
                        List<DoubleTimeObject_fjd_near> intervalDataEndList = new ArrayList<DoubleTimeObject_fjd_near>();
                        for (int index = start_index; index < inputDataList.size(); index++) {
                            // 计算左侧，先在intervalDataList中查询最近的有效数据，如没有则查询数据库；
                            // 只要找到就根据时间段长度进行分别处理
                            DoubleTimeObject serviceData = ComputeServiceEnergyLeft(dao_fjd_near, input.dao_key, time_period, rate, index,
                                    inputDataList, intervalDataBeginList, intervalDataEndList, interval);
                            if (serviceData != null) {
                                InsertUtil.Instance().InsertIntoDataList(outputDataList, serviceData);
                            }
                        }
                        // 计算丢数时段
                        for (int index = 0; index < intervalDataBeginList.size(); index++) {
                            DoubleTimeObject_fjd_near intervalDataBegin = intervalDataBeginList.get(index);
                            DoubleTimeObject_fjd_near intervalDataEnd = intervalDataEndList.get(index);

                            if (!ConstantCE.fjd_0_repair_servicedata_enable) {
                                continue;
                            }

                            List<DoubleTimeObject> tmpList = ComputeRepair(Dao_dataManager.Instance().Get(output.dao_type), output.dao_key,
                                    time_period, rate, intervalDataBegin, intervalDataEnd, interval);
                            for (int ii = 0; ii < tmpList.size(); ii++) {
                                DoubleTimeObject serviceData = tmpList.get(ii);
                                InsertUtil.Instance().InsertIntoDataList(outputDataList, serviceData);
                            }
                        }
                    }
                    outputDataList_all.addAll(outputDataList);

                    TimeSpan timeSpanOut = new TimeSpan(timefrom_last, timeto_last);
                    if (outputDataList.size() > 0) {
                        DoubleTimeObject data_first = outputDataList.get(0);
                        DoubleTimeObject data_final = outputDataList.get(outputDataList.size() - 1);
                        if (data_first.data_time.getTime() < timeSpanOut.timefrom.getTime()) {
                            timeSpanOut.timefrom = data_first.data_time;
                        }
                        if (data_final.data_time.getTime() > timeSpanOut.timeto.getTime()) {
                            timeSpanOut.timeto = data_final.data_time;
                        }
                    }
                    // 删除数据
                    Dao_dataManager.Instance().Get(output.dao_type).DeleteDataListGteLte(output.dao_key, time_period, timeSpanOut.timefrom,
                            timeSpanOut.timeto);
                    ConstantCE.SleepBetweenDeleteAndInsert();
                    // 保存数据
                    Dao_dataManager.Instance().Get(output.dao_type).InsertDataListGteLte(output.dao_key, time_period, outputDataList);
                    timeSpanListOut.add(timeSpanOut);
                }
            }

            // 统计
            if ("consumption".equals(output.data_class)) {
                CoreComputeUtil.Stat_consumption(output.dao_type, output.dao_key, timeSpanListOut, time_period, "1d");
            }
            for (TimeSpan timeSpan : timeSpanListOut) {
                // 保存日志
                {
                    JSONObject InsertObject = new JSONObject();
                    InsertObject.put("object_sign", object_sign);
                    InsertObject.put("instance_name", instance_name);
                    InsertObject.put("compute_round", compute_round);
                    InsertObject.put("output_sign", output.output_sign);
                    InsertObject.put("valid_time_from", sdf.format(timeSpan.timefrom));
                    InsertObject.put("valid_time_to", sdf.format(timeSpan.timeto));
                    InsertObject.put("operate_time_to", sdf.format(new Date()));
                    dao_log.InsertData(InsertObject);
                }
            }
        }

        return outputTimeSpanMap;
    }

    private static DoubleTimeObject ComputeServiceEnergyLeft(ImplDao_fjd_near dao_fjd_near, JSONObject dao_key, String time_period, Double rate,
                                                             int index, List<DoubleTimeObject_fjd_near> intervalDataList, List<DoubleTimeObject_fjd_near> intervalDataBeginList,
                                                             List<DoubleTimeObject_fjd_near> intervalDataEndList, long milliseconds) throws Exception {
        DoubleTimeObject serviceData = null;

        DoubleTimeObject_fjd_near recordDataPtr = intervalDataList.get(index);
        DoubleTimeObject_fjd_near lastRecordDataPtr = null;
        boolean find = false;
        if (index > 0) {
            DoubleTimeObject_fjd_near recordDataTmpPtr = intervalDataList.get(index - 1);
            // 找到左侧的有效数据
            lastRecordDataPtr = recordDataTmpPtr;
            find = true;
        }
        if (!find) {
            DoubleTimeObject_fjd_near lastRecordData = null;
            List<DoubleTimeObject_fjd_near> LastDataList = dao_fjd_near.GetDataListGteLte_fjd_near(dao_key, time_period,
                    new Date(recordDataPtr.data_time.getTime() - milliseconds * ConstantCE.SplitMaxSize),
                    new Date(recordDataPtr.data_time.getTime() - milliseconds), true);
            if (LastDataList != null && LastDataList.size() > 0) {
                lastRecordData = LastDataList.get(LastDataList.size() - 1);
            }

            if (lastRecordData != null) {
                lastRecordDataPtr = lastRecordData;
            } else {
                return serviceData;
            }
        }

        long timeSpanTemp = (recordDataPtr.data_time.getTime() - lastRecordDataPtr.data_time.getTime()) / (milliseconds);

        if (timeSpanTemp == 1) {
            double energy = recordDataPtr.data_value - lastRecordDataPtr.data_value;
            if (recordDataPtr.data_flag == 3 || recordDataPtr.data_flag >= 250) {
                energy = 0.0;
            }
            // 电表变比和相位比率
            if (rate != null) {
                energy *= rate;
            }
            serviceData = new DoubleTimeObject(lastRecordDataPtr.data_time, energy);

            // 负数处理
            if (!CheckNegative(lastRecordDataPtr.data_value, recordDataPtr.data_value) || !CheckData(milliseconds, energy)) {
                serviceData.data_value = 0.0;
            }
        } else {
            FindThenInsert(intervalDataBeginList, intervalDataEndList, lastRecordDataPtr, recordDataPtr);
        }
        return serviceData;
    }

    private static List<DoubleTimeObject> ComputeRepair(IDao_data dao, JSONObject dao_key, String time_period, Double rate,
                                                        DoubleTimeObject_fjd_near dataBegin, DoubleTimeObject_fjd_near dataEnd, long milliseconds) throws Exception {
        Calendar calendar = Calendar.getInstance();
        List<DoubleTimeObject> result = new ArrayList<DoubleTimeObject>();

        double energy = dataEnd.data_value - dataBegin.data_value;
        // 电表变比和相位比率
        energy *= rate;

        long timeSpanCount = (dataEnd.data_time.getTime() - dataBegin.data_time.getTime()) / (milliseconds);

        // 换表
        if (dataEnd.data_flag == 3 || dataEnd.data_flag >= 250) {
            for (int iii = 0; iii < timeSpanCount; iii++) {
                DoubleTimeObject serviceData = new DoubleTimeObject(new Date(dataBegin.data_time.getTime() + milliseconds * iii), 0.0);
                result.add(serviceData);
            }
            return result;
        }
        // 时间太长也拒绝修复
        if (timeSpanCount > ConstantCE.SplitMaxSize) {
            for (int iii = 0; iii < timeSpanCount; iii++) {
                DoubleTimeObject serviceData = new DoubleTimeObject(new Date(dataBegin.data_time.getTime() + milliseconds * iii), 0.0);
                result.add(serviceData);
            }
            return result;
        }
        // 负数处理
        if (!CheckNegative(dataBegin.data_value, dataEnd.data_value) || !CheckData(timeSpanCount * milliseconds, energy)) {
            for (int iii = 0; iii < timeSpanCount; iii++) {
                DoubleTimeObject serviceData = new DoubleTimeObject(new Date(dataBegin.data_time.getTime() + milliseconds * iii), 0.0);
                result.add(serviceData);
            }
            return result;
        }

        List<Double> estimateArray = new ArrayList<Double>();
        List<Double> uncertaintyArray = new ArrayList<Double>();
        GetHistory(dao, dao_key, dataBegin.data_time, dataEnd.data_time, estimateArray, uncertaintyArray, time_period);
        List<Double> estimateValue = new ArrayList<Double>();
        List<Double> uncertaintyValue = new ArrayList<Double>();

        Date tmpTime = dataBegin.data_time;
        for (int iii = 0; iii < timeSpanCount; iii++) {
            calendar.setTime(tmpTime);
            int day_of_week = calendar.get(Calendar.DAY_OF_WEEK);
            int hour_of_day = calendar.get(Calendar.HOUR_OF_DAY);
            int index = (day_of_week - 1) * 24 + hour_of_day;

            Double estimate = null;
            Double uncertainty = null;
            for (int index_num = 0; index_num < 7; index_num++) {
                estimate = estimateArray.get((index + index_num * 24) % 168);
                uncertainty = uncertaintyArray.get((index + index_num * 24) % 168);
                if (estimate != null) {
                    break;
                }
            }
            estimateValue.add(estimate);
            uncertaintyValue.add(uncertainty);
            result.add(new DoubleTimeObject(new Date(dataBegin.data_time.getTime() + milliseconds * iii), 0.0));

            tmpTime = new Date(tmpTime.getTime() + milliseconds);
        }

        SplitAlgorithm.Instance().SolveByRatio(estimateValue, energy, result);

        return result;
    }

    private static void GetHistory(IDao_data dao, JSONObject dao_key, Date lostTimeFrom1, Date lostTimeFrom2, List<Double> estimateList,
                                   List<Double> uncertaintyList, String time_period) throws Exception {
        long timeSpanWeeks = 1000L * 60 * 60 * 24 * 28;

        List<DoubleTimeObject> serviceDataList = dao.GetDataListGteLte(dao_key, time_period, new Date(lostTimeFrom1.getTime() - timeSpanWeeks),
                new Date(lostTimeFrom2.getTime() + timeSpanWeeks), false);

        List<DoubleTimeObject> dataList = new ArrayList<DoubleTimeObject>();
        for (int i = 0; i < serviceDataList.size(); i++) {
            DoubleTimeObject serviceData = serviceDataList.get(i);
            dataList.add(new DoubleTimeObject(serviceData.data_time, serviceData.data_value));
        }
        HistoryUtil.Instance().GetHistory(dataList, estimateList, uncertaintyList);

        return;
    }

    // 检查能耗是否超过额定功率
    private static boolean CheckData(long timespan, double energy) {
        double limit = 0.0;
        limit = ConstantCE.PowerLimit * (1.0 * timespan / (1000L * 60 * 60));
        return !(energy - limit > 0.001);
    }

    private static boolean CheckNegative(double dataLast, double dataNext) {
        return !(Math.abs(dataNext) - Math.abs(dataLast) < 0.0);
    }

    private static void FindThenInsert(List<DoubleTimeObject_fjd_near> intervalDataBeginList, List<DoubleTimeObject_fjd_near> intervalDataEndList,
                                       DoubleTimeObject_fjd_near lastData, DoubleTimeObject_fjd_near nextData) {
        int insertIndex = InsertUtil.Instance().FindInsertIndex(intervalDataBeginList, lastData);
        if (insertIndex != -1) {
            intervalDataBeginList.add(insertIndex, lastData);
            intervalDataEndList.add(insertIndex, nextData);
        }
    }
}
