package com.sagacloud.util.compute_engine.fjd_1;

import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.DateUtil;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject;
import com.sagacloud.util.split.ArrangeUtil;
import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Slf4j
public class ProcessUtil2 {
    public static void Process(String building, String meter, long funcid, String time_period, List<DoubleTimeObject> recordDataList,
                               List<DoubleTimeObject> badDataList, EntitySpan span, List<EntityValidSpan> validList) throws Exception {
        String collect_cycle = time_period;
        // 上下限过滤
        ArrangeUtil.Instance().FilterMaxMin(funcid, recordDataList, badDataList);
        ArrangeUtil.Instance().Filter_monotony(recordDataList, badDataList);

        long interval = DateUtil.Instance().get_about(collect_cycle);
        // 分段：数据间隔一定周期（默认4个计算周期）以内；单调（默认容忍-2.0）；不暴增（默认容忍6000.0）
        {
            int last_from = 0;
            int index_to = recordDataList.size() - 1;
            for (int i = 1; i < recordDataList.size(); i++) {
                DoubleTimeObject data = recordDataList.get(i);
                DoubleTimeObject last_data = recordDataList.get(i - 1);
                double energy = data.data_value - last_data.data_value;
                double power = energy / (1.0 * (data.data_time.getTime() - last_data.data_time.getTime()) / (1000L * 60 * 60));
                if (data.data_time.getTime() - last_data.data_time.getTime() < interval) {
                    power = energy / (1.0 * interval / (1000L * 60 * 60));
                }
                if (data.data_time.getTime() - last_data.data_time.getTime() <= interval * ConstantCE.fjd_1_span_max_between_interval_count
                        && data.data_value - last_data.data_value >= ConstantCE.fjd_1_monotony_sub && power <= ConstantCE.PowerLimit) {
                    if (i == index_to) {
                        int ccc = index_to + 1 - last_from;
                        if (ccc >= ConstantCE.fjd_1_span_min_data_count) {
                            validList.add(new EntityValidSpan(last_from, index_to));
                        }
                    }
                } else {
                    int ccc = i - last_from;
                    if (ccc >= ConstantCE.fjd_1_span_min_data_count) {
                        validList.add(new EntityValidSpan(last_from, i - 1));
                    }
                    last_from = i;
                }
            }
        }
        // 边缘处理
        for (int i = 1; i < validList.size(); i++) {
            EntityValidSpan validSpan = validList.get(i);
            EntityValidSpan validSpan_last = validList.get(i - 1);
            // 挨着
            DoubleTimeObject data = recordDataList.get(validSpan.index_from);
            DoubleTimeObject last_data = recordDataList.get(validSpan_last.index_to);
            if (data.data_value - last_data.data_value < ConstantCE.fjd_1_monotony_sub) {
                int[][] offsetArrayArray = {{1, 0}, {0, 1}, {1, 1}, {2, 0}, {0, 2}};
                for (int ii = 0; ii < offsetArrayArray.length; ii++) {
                    int[] offsetArray = offsetArrayArray[ii];
                    int left_start = validSpan_last.index_to - offsetArray[0];
                    int right_start = validSpan.index_from + offsetArray[1];
                    int[] ttt = {left_start - 3, left_start - 2, left_start - 1, left_start, right_start, right_start + 1, right_start + 2,
                            right_start + 3};
                    boolean match = true;
                    int cmp_count = 0;
                    for (int iii = 1; iii < ttt.length; iii++) {
                        if (ttt[iii - 1] >= 0 && ttt[iii] < recordDataList.size()) {
                            DoubleTimeObject recordData = recordDataList.get(ttt[iii]);
                            DoubleTimeObject recordDataLast = recordDataList.get(ttt[iii - 1]);
                            if (Math.abs(recordData.data_value) < Math.abs(recordDataLast.data_value)) {
                                match = false;
                                break;
                            } else {
                                cmp_count++;
                            }
                        }
                    }
                    if (match && cmp_count > 2) {
                        validSpan_last.index_to = left_start;
                        validSpan.index_from = right_start;
                        break;
                    }
                }
            } // end if
        }

        // 识别gap、bianda、bianxiao
        {
            int index_from = 0;
            int index_to = recordDataList.size() - 1;

            // 识别空隙
            for (int ii = 0; ii < validList.size(); ii++) {
                EntityValidSpan index_fromValid = validList.get(ii);
                if (ii == 0) {
                    if (index_fromValid.index_from > index_from) {
                        // 过滤掉一批
                        span.gapList_from.add(index_from);
                        span.gapList_to.add(index_fromValid.index_from - 1);
                    }
                }
                if (ii == validList.size() - 1) {
                    if (index_fromValid.index_to < index_to) {
                        // 过滤掉一批
                        span.gapList_from.add(index_fromValid.index_to + 1);
                        span.gapList_to.add(index_to);
                    }
                } else {
                    EntityValidSpan index_fromValidNext = validList.get(ii + 1);
                    if (index_fromValidNext.index_from - index_fromValid.index_to == 1) {
                        // 换表，底数变小
                        DoubleTimeObject data = recordDataList.get(index_fromValidNext.index_from);
                        DoubleTimeObject last_data = recordDataList.get(index_fromValid.index_to);
                        if (data.data_time.getTime() - last_data.data_time.getTime() <= interval * ConstantCE.fjd_1_span_max_between_interval_count) {
                            if (data.data_value - last_data.data_value >= ConstantCE.fjd_1_monotony_sub) {
                                span.changeList_bianda.add(ii);
                            } else {
                                span.changeList_bianxiao.add(ii);
                            }
                        }
                    } else {
                        // 过滤掉一批
                        span.gapList_from.add(index_fromValid.index_to + 1);
                        span.gapList_to.add(index_fromValidNext.index_from - 1);
                    }
                }
            }
        }

        // 旧数突变识别stay
        {
            {
                List<Integer> changeList_bianxiao_remove = new ArrayList<Integer>();
                List<Integer> changeList_bianda_remove = new ArrayList<Integer>();
                for (int iii = 0; iii < span.changeList_bianda.size(); iii++) {
                    int index_ttt = span.changeList_bianda.get(iii);
                    if (index_ttt + 1 > validList.size() - 1) {
                        continue;
                    }

                    EntityValidSpan index_fromValid = validList.get(index_ttt);
                    EntityValidSpan index_fromValidNext = validList.get(index_ttt + 1);
                    if (index_fromValid.index_to + 1 != index_fromValidNext.index_from) {
                        continue;
                    }

                    DoubleTimeObject biandahou = recordDataList.get(index_fromValidNext.index_from);
                    DoubleTimeObject biandaqian = recordDataList.get(index_fromValid.index_to);
                    int index_bianda = index_fromValid.index_to;
                    if (biandaqian.data_value < 0.001) {
                    } else {// 旧数突变识别
                        // 前一段不变超过限度且前面后面都有走
                        int index_first_euqal = index_bianda;
                        DoubleTimeObject first_equal_biandaqian = biandaqian;
                        for (int iiii = index_bianda - 1; iiii >= index_fromValid.index_from; iiii--) {
                            DoubleTimeObject biandaqianqian_tmp = recordDataList.get(iiii);
                            if (Math.abs(biandaqianqian_tmp.data_value - biandaqian.data_value) < 0.001) {
                                index_first_euqal = iiii;
                                first_equal_biandaqian = biandaqianqian_tmp;
                                continue;
                            } else {
                                break;
                            }
                        }
                        if (biandaqian.data_time.getTime() - first_equal_biandaqian.data_time.getTime() > interval
                                * ConstantCE.fjd_1_stay_min_count) {
                            if (index_first_euqal - 1 >= index_fromValid.index_from) {
                                double energy = biandahou.data_value - first_equal_biandaqian.data_value;
                                double power = energy
                                        / (1.0 * (biandahou.data_time.getTime() - first_equal_biandaqian.data_time.getTime()) / (1000L * 60 * 60));
                                DoubleTimeObject qianqian = recordDataList.get(index_first_euqal - 1);
                                DoubleTimeObject houhou = recordDataList.get(index_bianda + 1 + 1);
                                if (first_equal_biandaqian.data_value - qianqian.data_value > 0.001
                                        && houhou.data_value - biandahou.data_value > 0.001 && power <= ConstantCE.PowerLimit) {
                                    span.stayList_from.add(index_first_euqal);
                                    span.stayList_to.add(index_bianda + 1);
                                    changeList_bianda_remove.add(iii);
                                }
                            }
                        }
                    }
                }
                for (int iii = changeList_bianxiao_remove.size() - 1; iii >= 0; iii--) {
                    span.changeList_bianxiao.remove(changeList_bianxiao_remove.get(iii).intValue());
                }
                for (int iii = changeList_bianda_remove.size() - 1; iii >= 0; iii--) {
                    span.changeList_bianda.remove(changeList_bianda_remove.get(iii).intValue());
                }
            }
        }

        // 识别零段zero
        {
            {
                List<Integer> changeList_bianxiao_remove = new ArrayList<Integer>();
                List<Integer> changeList_bianda_remove = new ArrayList<Integer>();
                for (int iii = 0; iii < span.changeList_bianxiao.size(); iii++) {
                    int index_ttt = span.changeList_bianxiao.get(iii);
                    if (index_ttt + 1 > validList.size() - 1) {
                        continue;
                    }

                    EntityValidSpan index_fromValid = validList.get(index_ttt);
                    EntityValidSpan index_fromValidNext = validList.get(index_ttt + 1);
                    if (index_fromValid.index_to + 1 != index_fromValidNext.index_from) {
                        continue;
                    }

                    int index_bianxiao = index_fromValid.index_to;
                    DoubleTimeObject bianxiaoqian = recordDataList.get(index_bianxiao);
                    DoubleTimeObject bianxiaohou = recordDataList.get(index_fromValidNext.index_from);
                    if (bianxiaohou.data_value < 0.001) {// 识别零段
                        // 寻找后一个变化
                        boolean find = false;
                        int index_to = index_fromValidNext.index_to;
                        if (index_ttt + 1 + 1 <= validList.size() - 1) {
                            EntityValidSpan index_fromValidNextNext = validList.get(index_ttt + 1 + 1);
                            if (index_fromValidNextNext.index_from == index_fromValidNext.index_to + 1) {
                                index_to = index_fromValidNextNext.index_to;
                            }
                        }
                        int iiii_tmp = -1;
                        for (int iiii = index_bianxiao + 1 + 1; iiii <= index_to; iiii++) {
                            DoubleTimeObject bianxiaohou_tmp = recordDataList.get(iiii);
                            if (bianxiaohou_tmp.data_value > 0.001) {
                                iiii_tmp = iiii;
                                find = true;
                                break;
                            }
                        }
                        if (find) {
                            DoubleTimeObject biandahou = recordDataList.get(iiii_tmp);
                            if (biandahou.data_value - bianxiaoqian.data_value >= ConstantCE.fjd_1_monotony_sub) {
                                // 找到
                                span.zeroList_from.add(index_bianxiao);
                                span.zeroList_to.add(iiii_tmp);
                                changeList_bianxiao_remove.add(iii);
                                for (int iiiii = 0; iiiii < span.changeList_bianda.size(); iiiii++) {
                                    EntityValidSpan valid_tmp = validList.get(span.changeList_bianda.get(iiiii));
                                    if (valid_tmp.index_to == iiii_tmp - 1) {
                                        changeList_bianda_remove.add(iiiii);
                                    }
                                }
                            }
                        }
                    }
                }
                for (int iii = changeList_bianxiao_remove.size() - 1; iii >= 0; iii--) {
                    span.changeList_bianxiao.remove(changeList_bianxiao_remove.get(iii).intValue());
                }
                for (int iii = changeList_bianda_remove.size() - 1; iii >= 0; iii--) {
                    span.changeList_bianda.remove(changeList_bianda_remove.get(iii).intValue());
                }
            }
        }

        // 其他问题
    }

    public static void print(String building, String meter, long funcid, List<DoubleTimeObject> recordDataList, EntitySpan span,
                             List<EntityValidSpan> validList) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        // 打印识别情况
        if (recordDataList.size() > 0) {
            int index_from = 0;
            int index_to = recordDataList.size() - 1;

            log.info("\n" + "span" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + sdf.format(recordDataList.get(index_from).data_time)
                    + "\t" + "\t" + sdf.format(recordDataList.get(index_to).data_time) + "\t");

            int index_gap = 0;
            int index_bianxiao = 0;
            int index_bianda = 0;
            int index_zero = 0;
            int index_stay = 0;
            while (index_bianxiao < span.changeList_bianxiao.size() || index_bianda < span.changeList_bianda.size()
                    || index_zero < span.zeroList_from.size() || index_stay < span.stayList_from.size()) {
                Date first_date = null;
                DoubleTimeObject gap_from = null;
                if (index_gap < span.gapList_from.size()) {
                    gap_from = recordDataList.get(span.gapList_from.get(index_gap));
                    if (first_date == null || gap_from.data_time.getTime() < first_date.getTime()) {
                        first_date = gap_from.data_time;
                    }
                }
                DoubleTimeObject bianxiao = null;
                if (index_bianxiao < span.changeList_bianxiao.size()) {
                    EntityValidSpan index_fromValid = validList.get(span.changeList_bianxiao.get(index_bianxiao));
                    bianxiao = recordDataList.get(index_fromValid.index_to);
                    if (first_date == null || bianxiao.data_time.getTime() < first_date.getTime()) {
                        first_date = bianxiao.data_time;
                    }
                }
                DoubleTimeObject bianda = null;
                if (index_bianda < span.changeList_bianda.size()) {
                    EntityValidSpan index_fromValid = validList.get(span.changeList_bianda.get(index_bianda));
                    bianda = recordDataList.get(index_fromValid.index_to);
                    if (first_date == null || bianda.data_time.getTime() < first_date.getTime()) {
                        first_date = bianda.data_time;
                    }
                }
                DoubleTimeObject zero_from = null;
                if (index_zero < span.zeroList_from.size()) {
                    zero_from = recordDataList.get(span.zeroList_from.get(index_zero));
                    if (first_date == null || zero_from.data_time.getTime() < first_date.getTime()) {
                        first_date = zero_from.data_time;
                    }
                }
                DoubleTimeObject stay_from = null;
                if (index_stay < span.stayList_from.size()) {
                    stay_from = recordDataList.get(span.stayList_from.get(index_stay));
                    if (first_date == null || stay_from.data_time.getTime() < first_date.getTime()) {
                        first_date = stay_from.data_time;
                    }
                }
                if (gap_from != null && first_date.getTime() == gap_from.data_time.getTime()) {
                    DoubleTimeObject gap_to = recordDataList.get(span.gapList_to.get(index_gap));
                    log.warn("gap" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + sdf.format(gap_from.data_time) + "\t"
                            + gap_from.data_value + "\t" + sdf.format(gap_to.data_time) + "\t" + gap_to.data_value);
                    index_gap++;
                } else if (bianxiao != null && first_date.getTime() == bianxiao.data_time.getTime()) {
                    EntityValidSpan index_fromValid = validList.get(span.changeList_bianxiao.get(index_bianxiao));
                    DoubleTimeObject bian_hou = recordDataList.get(index_fromValid.index_to + 1);
                    log.warn("bianxiao" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + sdf.format(bianxiao.data_time) + "\t"
                            + bianxiao.data_value + "\t" + sdf.format(bian_hou.data_time) + "\t" + bian_hou.data_value);
                    index_bianxiao++;
                } else if (bianda != null && first_date.getTime() == bianda.data_time.getTime()) {
                    EntityValidSpan index_fromValid = validList.get(span.changeList_bianda.get(index_bianda));
                    DoubleTimeObject bian_hou = recordDataList.get(index_fromValid.index_to + 1);
                    log.warn("bianda" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + sdf.format(bianda.data_time) + "\t"
                            + bianda.data_value + "\t" + sdf.format(bian_hou.data_time) + "\t" + bian_hou.data_value);
                    index_bianda++;
                } else if (zero_from != null && first_date.getTime() == zero_from.data_time.getTime()) {
                    DoubleTimeObject zero_to = recordDataList.get(span.zeroList_to.get(index_zero));
                    log.warn("zero" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + sdf.format(zero_from.data_time) + "\t"
                            + zero_from.data_value + "\t" + sdf.format(zero_to.data_time) + "\t" + zero_to.data_value);
                    index_zero++;
                } else if (stay_from != null && first_date.getTime() == stay_from.data_time.getTime()) {
                    DoubleTimeObject stay_to = recordDataList.get(span.stayList_to.get(index_stay));
                    log.warn("stay" + "\t" + building + "\t" + meter + "\t" + funcid + "\t" + sdf.format(stay_from.data_time) + "\t"
                            + stay_from.data_value + "\t" + sdf.format(stay_to.data_time) + "\t" + stay_to.data_value);
                    index_stay++;
                }
            }
        }
    }
}
