package com.sagacloud.util.compute_engine.util;

import cn.hutool.core.io.resource.ResourceUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import java.io.File;
import java.io.InputStream;
import java.util.*;

@Slf4j
public class ConstantCE {
    public static String Stat_time_period_fjd_near = "1d";
    public static String Stat_time_period_fjd_rate = "1d";

    public static String Server_name;
    public static String compute_engine;
    public static boolean time_period_seperate = false;
    public static boolean time_period_seperate_save_two = false;
    public static boolean servicedata_use_survey = false;
    public static String database_name;

    public static String zone;
    public static int thread_count = 1;
    public static boolean job_split = false;
    public static int job_thread_count = 1;
    public static int job_batch_count = 1;

    public static String config_mode = "default";
    public static List<String> config_instanceList = new ArrayList<String>();

    public static Map<Long, Boolean> funcid_IncludesMap = new HashMap<Long, Boolean>();
    public static Map<Long, Boolean> funcid_ExcludesMap = new HashMap<Long, Boolean>();

    public static boolean use_original_funcidMap = false;
    public static Map<Long, Long> original_funcidMap = new HashMap<Long, Long>();
    public static Map<Long, Double> OriginalDataFilterMaxMap = new HashMap<Long, Double>();
    public static Map<Long, Double> OriginalDataFilterMinMap = new HashMap<Long, Double>();
    public static Map<Long, List<Double>> OriginalDataFilterValuesMap = new HashMap<Long, List<Double>>();
    public static boolean stat_inst_use_ori = true;
    public static boolean Inst_fjd_interpolate = true;
    public static String Inst_fjd_use_direction = "two";
    public static boolean Stat_enable = false;
    public static int interval_seconds_stat_inststat = 3600;
    public static int interval_seconds_stat_consumption = 21600;

    public static double PowerLimit = 10000.0;
    public static boolean expression_negative_to_0 = false;
    public static boolean high_density_enable = false;
    public static int SplitMaxSize = 7 * 24 * 4;
    public static int fjd_0_MaxMinute = 60 * 24 * 7;
    public static int fjd_0_LagDay = 30;
    public static boolean fjd_0_repair_servicedata_enable = true;
    public static boolean fjd_0_loss_rate_enable = true;

    public static boolean fjd_1_enable = false;
    public static long fjd_1_compute_min_span_second = 60 * 60 * 8;// 28800
    public static int interval_seconds_fjd_1 = 60 * 60;// 3600
    public static int fjd_1_lag_cycle_count = 2;
    public static int fjd_1_span_min_data_count = 13;
    public static int fjd_1_span_max_between_interval_count = 4;// 15min--1hour
    public static int fjd_1_stay_min_count = 96;// 15min--24hour
    public static int fjd_1_max_analyse_before_day = 30;
    public static int fjd_1_max_analyse_after_interval_count = 8;
    public static double fjd_1_monotony_sub = -2.0;

    public static boolean use_logger = false;
    public static List<String> loggerList = new ArrayList<String>();

    public static int SleepBetweenDeleteAndInsert = 0;

    public static boolean original_delay_enable = false;
    public static int original_delay_period_minute = 15;
    public static int original_delay_goodperiodcount = 2;
    public static int original_delay_delayperiodcount = 8;
    public static int original_delay_thread_count = 1;

    public static String zk_root;
    public static String zk_initbegin;
    public static String zk_initend;

    public static String zk_instance;
    public static String zk_status;
    public static String zk_status_request;
    public static String zk_status_current;
    public static String zk_lock;
    public static String zk_compute_interval;
    public static String zk_compute_time_last;

    static {
        try {
            try (InputStream stream = getStream("config.xml")) {
                SAXReader saxReader = new SAXReader();
                Document document = saxReader.read(stream);
                if (document != null) {
                    Iterator iter;
                    Element element;
                    iter = document.selectNodes("/root/Server").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        Server_name = element.attribute("name").getValue();
                    }

                    iter = document.selectNodes("/root/compute_engine").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        compute_engine = "/" + element.getText();
                    }
                    iter = document.selectNodes("/root/zone").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        zone = element.getText();
                    }
                    iter = document.selectNodes("/root/database_name").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        database_name = element.getText();
                    }
                    iter = document.selectNodes("/root/time_period_seperate").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        time_period_seperate = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/time_period_seperate_save_two").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        time_period_seperate_save_two = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/servicedata_use_survey").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        servicedata_use_survey = "true".equalsIgnoreCase(element.getText());
                    }

                    iter = document.selectNodes("/root/thread_count").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        thread_count = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/job_split").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        job_split = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/job_thread_count").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        job_thread_count = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/job_batch_count").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        job_batch_count = Integer.parseInt(element.getText());
                    }

                    iter = document.selectNodes("/root/config_mode").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        config_mode = element.getText();
                    }
                    iter = document.selectNodes("/root/config_instanceList/config_instance").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        String object_sign = element.attribute("object_sign").getValue();
                        String instance_name = element.attribute("instance_name").getValue();
                        config_instanceList.add(object_sign + "_" + instance_name);
                    }

                    iter = document.selectNodes("/root/funcid_Includes/Entity").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        funcid_IncludesMap.put(Long.parseLong(element.getText()), true);
                    }
                    iter = document.selectNodes("/root/funcid_Excludes/Entity").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        funcid_ExcludesMap.put(Long.parseLong(element.getText()), true);
                    }

                    iter = document.selectNodes("/root/use_original_funcidMap").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        use_original_funcidMap = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/original_funcidMap/item").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        String survey_funcid = element.attribute("survey_funcid").getValue();
                        String original_funcid = element.attribute("original_funcid").getValue();
                        original_funcidMap.put(Long.parseLong(survey_funcid), Long.parseLong(original_funcid));
                    }
                    iter = document.selectNodes("/root/OriginalDataFilterList/OriginalDataFilter").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        long funcid = Long.parseLong(element.attribute("funcid").getText());
                        if (element.attribute("max") != null) {
                            double max = Double.parseDouble(element.attribute("max").getText());
                            OriginalDataFilterMaxMap.put(funcid, max);
                        }
                        if (element.attribute("min") != null) {
                            double min = Double.parseDouble(element.attribute("min").getText());
                            OriginalDataFilterMinMap.put(funcid, min);
                        }
                        if (element.attribute("bad_values") != null) {
                            String[] splits = element.attribute("bad_values").getText().split(",");
                            List<Double> bad_values = new ArrayList<Double>();
                            for (String split : splits) {
                                bad_values.add(Double.parseDouble(split));
                            }
                            OriginalDataFilterValuesMap.put(funcid, bad_values);
                        }
                    }
                    iter = document.selectNodes("/root/stat_inst_use_ori").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        stat_inst_use_ori = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/Inst_fjd_interpolate").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        Inst_fjd_interpolate = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/Inst_fjd_use_direction").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        Inst_fjd_use_direction = element.getText();
                    }
                    iter = document.selectNodes("/root/Stat_enable").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        Stat_enable = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/interval_seconds_stat_inststat").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        interval_seconds_stat_inststat = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/interval_seconds_stat_consumption").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        interval_seconds_stat_consumption = Integer.parseInt(element.getText());
                    }

                    iter = document.selectNodes("/root/PowerLimit").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        PowerLimit = Double.parseDouble(element.getText());
                    }
                    iter = document.selectNodes("/root/expression_negative_to_0").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        expression_negative_to_0 = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/high_density_enable").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        high_density_enable = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/SplitMaxSize").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        SplitMaxSize = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_0_MaxDay").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        int fjd_0_MaxDay = Integer.parseInt(element.getText());
                        fjd_0_MaxMinute = 60 * 24 * fjd_0_MaxDay;
                    }
                    iter = document.selectNodes("/root/fjd_0_MaxHour").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        int fjd_0_MaxHour = Integer.parseInt(element.getText());
                        fjd_0_MaxMinute = 60 * fjd_0_MaxHour;
                    }
                    iter = document.selectNodes("/root/fjd_0_MaxMinute").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_0_MaxMinute = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_0_LagDay").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_0_LagDay = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_0_repair_servicedata_enable").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_0_repair_servicedata_enable = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_0_loss_rate_enable").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_0_loss_rate_enable = "true".equalsIgnoreCase(element.getText());
                    }

                    iter = document.selectNodes("/root/fjd_1_enable").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_1_enable = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_1_compute_min_span_second").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_1_compute_min_span_second = Long.parseLong(element.getText());
                    }
                    iter = document.selectNodes("/root/interval_seconds_fjd_1").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        interval_seconds_fjd_1 = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_1_lag_cycle_count").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_1_lag_cycle_count = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_1_span_min_data_count").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_1_span_min_data_count = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_1_span_max_between_interval_count").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_1_span_max_between_interval_count = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_1_stay_min_count").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_1_stay_min_count = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_1_max_analyse_before_day").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_1_max_analyse_before_day = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_1_max_analyse_after_interval_count").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_1_max_analyse_after_interval_count = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/fjd_1_monotony_sub").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_1_monotony_sub = Double.parseDouble(element.getText());
                    }

                    iter = document.selectNodes("/root/use_logger").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        use_logger = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/loggerList/table").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        loggerList.add(element.getText());
                    }

                    iter = document.selectNodes("/root/SleepBetweenDeleteAndInsert").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        SleepBetweenDeleteAndInsert = Integer.parseInt(element.getText());
                    }

                    iter = document.selectNodes("/root/original_delay_enable").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        original_delay_enable = "true".equalsIgnoreCase(element.getText());
                    }
                    iter = document.selectNodes("/root/original_delay_period_minute").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        original_delay_period_minute = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/original_delay_goodperiodcount").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        original_delay_goodperiodcount = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/original_delay_delayperiodcount").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        original_delay_delayperiodcount = Integer.parseInt(element.getText());
                    }
                    iter = document.selectNodes("/root/original_delay_thread_count").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        original_delay_thread_count = Integer.parseInt(element.getText());
                    }
                }
            }

            {
                zk_root = ConstantCE.compute_engine + "/" + ConstantCE.zone;
                zk_initbegin = ConstantCE.compute_engine + "/" + ConstantCE.zone + "/initbegin";
                zk_initend = ConstantCE.compute_engine + "/" + ConstantCE.zone + "/initend";

                zk_instance = ConstantCE.compute_engine + "/" + ConstantCE.zone + "/instance";
                zk_status = ConstantCE.compute_engine + "/" + ConstantCE.zone + "/status";
                zk_status_request = ConstantCE.compute_engine + "/" + ConstantCE.zone + "/status/status_request";
                zk_status_current = ConstantCE.compute_engine + "/" + ConstantCE.zone + "/status/status_current";
                zk_lock = ConstantCE.compute_engine + "/" + ConstantCE.zone + "/lock";
                zk_compute_interval = ConstantCE.compute_engine + "/" + ConstantCE.zone + "/compute_interval";
                zk_compute_time_last = ConstantCE.compute_engine + "/" + ConstantCE.zone + "/compute_time_last";
            }
        } catch (Exception e) {
            log.error(e.getMessage(),e);
        }
    }

    public static void SleepBetweenDeleteAndInsert() {
        if (SleepBetweenDeleteAndInsert > 0) {
            try {
                Thread.sleep(SleepBetweenDeleteAndInsert);
            } catch (InterruptedException e) {
                log.error(e.getMessage(),e);
            }
        }
    }

    public static InputStream getStream(String resourc) {
        if (resourc.startsWith(File.separator)) {
            resourc = StrUtil.removePrefix(resourc, File.separator);
        }
        try {
            String filePath = File.separator + "usr" + File.separator + "local" + File.separator + "etc" + File.separator + resourc;
            InputStream stream = ResourceUtil.getStream(filePath);
            if (stream != null) {
                log.warn("getStream success 0" + "\t" + filePath);
                return stream;
            }
        } catch (Exception e) {
        }
        try {
            // jar包同级config目录
            String filePath = System.getProperty("user.dir") + File.separator + "config" + File.separator + resourc;
            InputStream stream = ResourceUtil.getStream(filePath);
            if (stream != null) {
                log.warn("getStream success 1" + "\t" + filePath);
                return stream;
            }
        } catch (Exception e) {
        }
        try {
            // jar包同级目录
            String filePath = System.getProperty("user.dir") + File.separator + resourc;
            InputStream stream = ResourceUtil.getStream(filePath);
            if (stream != null) {
                log.warn("getStream success 2" + "\t" + filePath);
                return stream;
            }
        } catch (Exception e) {
        }
        try {
            // ClassPath目录
            InputStream in = new org.springframework.core.io.ClassPathResource(File.separator + resourc).getInputStream();
            if (in != null) {
                log.warn("getStream success 3" + "\t" + "ClassPathResource" + "\t" + resourc);
                return in;
            }
        } catch (Exception e) {
        }
        try {
            InputStream stream = ConstantCE.class.getResourceAsStream(File.separator + resourc);
            if (stream != null) {
                log.warn("getStream success 4" + "\t" + "getResourceAsStream" + "\t" + resourc);
                return stream;
            }
        } catch (Exception e) {
        }
        log.warn("getStream fail " + resourc);
        return null;
    }
}
