package com.sagacloud.util.math;

import lombok.extern.slf4j.Slf4j;

import java.lang.reflect.Method;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
@Slf4j
public class MathUtil {
    private static final MathUtil instance = new MathUtil();
    public String[] fun0p = {"year", "month", "day", "hour", "minute", "second", "dayofweek", "dayofyear", "totalsecond"};
    public String[] fun1p = {"abs", "acos", "asin", "atan", "ceil", "cos", "cosh", "exp", "floor", "log", "log10", "sin", "sinh", "sqrt", "tan", "tanh"};

    // 内部2元函数：+ * - /
    public String[] fun2p = {"atan2", "fmod", "pow", "max", "min"};
    public String[] cmp = {">", ">=", "<", "<=", "==", "!="};

    private MathUtil() {

    }

    public static MathUtil Instance() {
        return instance;
    }

    public boolean diy_funname(String[] funs, String name) {
        for (int i = 0; i < funs.length; i++) {
            if (funs[i].equals(name)) {
                return true;
            }
        }
        return false;
    }

    public double funnp_value(String fun_name, List<Double> children) {
        double result = 0.0;
        if ("max".equals(fun_name)) {
            boolean find = false;
            for (Double child : children) {
                if (!find) {
                    find = true;
                    result = child;
                } else {
                    if (result < child) {
                        result = child;
                    }
                }
            }
        } else if ("min".equals(fun_name)) {
            boolean find = false;
            for (Double child : children) {
                if (!find) {
                    find = true;
                    result = child;
                } else {
                    if (result > child) {
                        result = child;
                    }
                }
            }
        }
        return result;
    }

    public double fun0p_value(String fun_name) {
        Date date = new Date();
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        if ("year".equals(fun_name)) {
            return calendar.get(Calendar.YEAR);
        } else if ("month".equals(fun_name)) {
            return calendar.get(Calendar.MONTH) + 1;
        } else if ("day".equals(fun_name)) {
            return calendar.get(Calendar.DAY_OF_MONTH);
        } else if ("hour".equals(fun_name)) {
            return calendar.get(Calendar.HOUR_OF_DAY);
        } else if ("minute".equals(fun_name)) {
            return calendar.get(Calendar.MINUTE);
        } else if ("second".equals(fun_name)) {
            return calendar.get(Calendar.SECOND);
        } else if ("dayofweek".equals(fun_name)) {
            return calendar.get(Calendar.DAY_OF_WEEK);
        } else if ("dayofyear".equals(fun_name)) {
            return calendar.get(Calendar.DAY_OF_YEAR);
        } else if ("totalsecond".equals(fun_name)) {
            return date.getTime() / 1000L;
        } else {
            double result = 0.0;
            Class<?> mathClass = Math.class;
            try {
                Method method = mathClass.getMethod(fun_name);
                result = (Double) method.invoke(mathClass, new Object[]{});
            } catch (Exception e) {
                log.error(e.getMessage(),e);
            }
            return result;
        }
    }

    public double fun1p_value(String fun_name, double value1) {
        double result = 0.0;
        Class<?> mathClass = Math.class;
        try {
            Method method = mathClass.getMethod(fun_name, double.class);
            result = (Double) method.invoke(mathClass, new Object[]{value1});
        } catch (Exception e) {
            log.error(e.getMessage(),e);
        }
        return result;
    }

    public double fun2p_value(String fun_name, double value1, double value2) {
        double result = 0.0;
        Class<?> mathClass = Math.class;
        try {
            Method method = mathClass.getMethod(fun_name, double.class, double.class);
            result = (Double) method.invoke(mathClass, new Object[]{value1, value2});
        } catch (Exception e) {
            log.error(e.getMessage(),e);
        }
        return result;
    }

    public boolean cmp_value(String cmp_name, double value1, double value2) {
        if (">".equals(cmp_name)) {
            return value1 > value2;
        } else if (">=".equals(cmp_name)) {
            return value1 >= value2;
        } else if ("<".equals(cmp_name)) {
            return value1 < value2;
        } else if ("<=".equals(cmp_name)) {
            return value1 <= value2;
        } else if ("==".equals(cmp_name)) {
            return value1 == value2;
        } else if ("!=".equals(cmp_name)) {
            return value1 != value2;
        }
        return false;
    }
}
