package test;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import com.zillion.database.agent.ZillionAgent;
import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;
import java.util.*;

@Slf4j
public class delete_instant_Thread extends Thread {
    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

    ZillionAgent agent;
    String database_name;
    String[] months;

    public delete_instant_Thread(String database_name, String[] months) {

        this.database_name = database_name;
        this.months = months;
    }

    @Override
    public void run() {
        while (true) {
            String item = delete_instant.Pop();
            if (item == null) {
                break;
            }

            String building = item;
            try {
                this.Process(building);
            } catch (Exception e) {
                log.error(e.getMessage(),e);
            }
        }
    }

    void Process(String building) throws Exception {
        Map<String, List<Long>> funcidListMap = new HashMap<String, List<Long>>();
        JSONObject Criteria = new JSONObject();
        Criteria.put("building", building);
        JSONArray resultContent = QueryUtil.select(database_name, "original_present", Criteria);
        for (int i = 0; i < resultContent.size(); i++) {
            JSONObject content = (JSONObject) resultContent.get(i);
            String meter = (String) content.get("meter");
            Long funcid = (Long) content.get("funcid");
            if (funcid == 4 || funcid == 5 || funcid == 6 || funcid == 11 || funcid == 12 || funcid == 13
                    || funcid == 18 || funcid == 19 || funcid == 20 || funcid == 21 || funcid == 22 || funcid == 23
                    || funcid == 24 || funcid == 25 || funcid == 26 || funcid == 27 || funcid == 28 || funcid == 29
                    || funcid == 33 || funcid == 308 || funcid == 316 || funcid == 2091 || funcid == 2092
                    || funcid == 2092) {
            } else if (funcid == 10000004 || funcid == 10000005 || funcid == 10000006 || funcid == 10000011
                    || funcid == 10000012 || funcid == 10000013 || funcid == 10000018 || funcid == 10000019
                    || funcid == 10000020 || funcid == 10000021 || funcid == 10000022 || funcid == 10000023
                    || funcid == 10000024 || funcid == 10000025 || funcid == 10000026 || funcid == 10000027
                    || funcid == 10000028 || funcid == 10000029 || funcid == 10000033 || funcid == 10000308
                    || funcid == 10000316 || funcid == 10002091 || funcid == 10002092 || funcid == 10002092) {
            } else if (funcid == 20000004 || funcid == 20000005 || funcid == 20000006 || funcid == 20000011
                    || funcid == 20000012 || funcid == 20000013 || funcid == 20000018 || funcid == 20000019
                    || funcid == 20000020 || funcid == 20000021 || funcid == 20000022 || funcid == 20000023
                    || funcid == 20000024 || funcid == 20000025 || funcid == 20000026 || funcid == 20000027
                    || funcid == 20000028 || funcid == 20000029 || funcid == 20000033 || funcid == 20000308
                    || funcid == 20000316 || funcid == 20002091 || funcid == 20002092 || funcid == 20002092) {
            } else {
                continue;
            }
            if (!funcidListMap.containsKey(meter)) {
                funcidListMap.put(meter, new ArrayList<Long>());
            }
            funcidListMap.get(meter).add(funcid);
        }
        String[] meter_array = funcidListMap.keySet().toArray(new String[0]);
        Arrays.sort(meter_array);
        for (String meter : meter_array) {
            List<Long> funcidList = funcidListMap.get(meter);
            long count_delete = 0;
            for (Long funcid : funcidList) {
                for (String month : months) {
                    JSONObject CriteriaInner = new JSONObject();
                    CriteriaInner.put("building", building);
                    CriteriaInner.put("meter", meter);
                    CriteriaInner.put("funcid", funcid);
                    count_delete += QueryUtil.delete(database_name, "original_month" + "_" + month,
                            CriteriaInner);
                }
                // {
                // JSONObject CriteriaInner = new JSONObject();
                // CriteriaInner.put("building", building);
                // CriteriaInner.put("meter", meter);
                // CriteriaInner.put("funcid", funcid);
                // count_delete += QueryUtil.delete( database_name,
                // "original_present", CriteriaInner);
                // }
            }
            log.warn(
                    building + "\t" + meter + "\t" + "funcid:" + funcidList.size() + "\t" + "delete:" + count_delete);
        }
    }
}
